﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using DevExpress.XtraGrid;
using System.Globalization;
using DevExpress.XtraPrinting;
using DevComponents.DotNetBar;
//using Microsoft.Office.Interop.Excel; 

namespace books
{
    public partial class Form2 : DevComponents.DotNetBar.Office2007Form
    {
        public Form2(int row, string function)
        {
            bookdetails = new bookdetails();
            InitializeComponent();
            role = function;
            rowid = row;
            DataTable book_info = new DataTable();
            string temp;
            panel1.Controls.Add(bookdetails);
            bookdetails.Dock = DockStyle.Fill;
            book_info.Locale = System.Globalization.CultureInfo.InvariantCulture;
            FillBook();
            //trim time from datetime
            for (int i = 0; i < bookdetails.gridView1.RowCount; i++)
            {
                temp = bookdetails.gridView1.GetRowCellValue(i, "Date").ToString();
                if (temp.Length > 4)
                {
                    if (!(comboBoxEx1.Items.Contains(temp.Substring(temp.Length - 4))))
                    {
                        comboBoxEx1.Items.Add(temp.Substring(temp.Length - 4));
                    }
                }
            }

            textBoxX1.Modified = false;
            textBoxX2.Modified = false;
            textBoxX3.Modified = false;
          //  bookdetails.gridView1.Columns["Sum"].SummaryItem.Tag = bookdetails.gridView1.GetRowCellValue(bookdetails.gridView1.RowCount, "Sum");

        }

        private void buttonX3_Click(object sender, EventArgs e)
        {

            Close();
        }

        private void buttonX2_Click(object sender, EventArgs e)
        {
            add_book_transaction newapp = new add_book_transaction(rowid, "add");
            newapp.Show();
            newapp.Focus();
        }

        private void buttonX1_Click(object sender, EventArgs e)
        {
            string timeMark = DateTime.Now.ToString("yyyyMMdd_HHmmss");
            string desktop_path = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory).ToString();
            string fastExportFilePath = desktop_path + "\\books_" + textBoxX1.Text.ToString() + "_" + textBoxX3.Text.ToString() + "_" + timeMark + ".xls";
            
            //DataSet ds = new DataSet();

            
            //try
            //{
            //    DbWrapper myWrapper = new DbWrapper(Program.server_ip, Program.database, Program.username, "newton");
            //    myWrapper.Connect();
            //    Program.table1 = myWrapper.export_books(rowid);
                
            //    myWrapper.Disconnect();
            //    //Program.table1.TableName = "Book" + textBoxX1.Text.ToString() + "_" + textBoxX3.Text.ToString();
            //    Program.table1.TableName = "Book";
            //    Program.table1.Locale = System.Globalization.CultureInfo.InvariantCulture;
            //    ds.Tables.Add(Program.table1);

            //}

            //catch (Exception excp)
            //{
            //    Exception myExcp = new Exception("Could not view transaction " + excp.Message, excp);
            //    throw (myExcp);
            //}


            //FastExportingMethod.ExportToExcel(ds, @fastExportFilePath);

            //Microsoft.Office.Interop.Excel.Application excelApp = new Microsoft.Office.Interop.Excel.ApplicationClass();
            
            //Microsoft.Office.Interop.Excel.Workbook excelWorkbook = excelApp.Workbooks.Open(@fastExportFilePath, 0, false, 5, "", "", false, Microsoft.Office.Interop.Excel.XlPlatform.xlWindows, "", true, false, 0, true, false, false);

            //excelApp.Visible = true;

            DevExpress.XtraPrinting.PrintingSystem ps = new DevExpress.XtraPrinting.PrintingSystem();

            // Create a link that will print a control.
            DevExpress.XtraPrinting.PrintableComponentLink link = new PrintableComponentLink(ps);
            // Specify the control to be printed.
            link.Component = bookdetails.gridControl1; 
            link.CreateReportHeaderArea += new CreateAreaEventHandler(printableComponentLink2_CreateReportHeaderArea);
            // Generate the report.
            link.CreateDocument();

            // Export the report to a PDF file.

            link.PrintingSystem.ExportToXls(@fastExportFilePath);
            
            // Use the code below if you want the created file to be automatically
            // opened in the appropriate application.
            System.Diagnostics.Process process = new System.Diagnostics.Process();
            process.StartInfo.FileName = @fastExportFilePath;
            process.Start();

        }


        private void ShowGridPreview(GridControl grid)
        {
            // Check whether the GridControl can be previewed.
            if (!grid.IsPrintingAvailable)
            {
                MessageBox.Show("The 'DevExpress.XtraPrinting' library is not found", "Error");
                return;
            }

            // Open the Preview window.
            grid.ShowPrintPreview();
        }

        private void panel1_Enter(object sender, EventArgs e)
        {
            
        }

        public void FillBook()
        {
            DataTable book_info = new DataTable();
            
            try
            {
            DbWrapper myWrapper = new DbWrapper(Program.server_ip, Program.database, Program.username, "newton");


            myWrapper.Connect();
            
            book_info = myWrapper.book_details(rowid);
            book_info.Locale = System.Globalization.CultureInfo.InvariantCulture;
            bookdetails.gridControl1.DataSource = book_info;
            
            myWrapper.Disconnect();

            textBoxX1.Text = book_info.Rows[0]["Authorlast"].ToString();
            textBoxX2.Text = book_info.Rows[0]["Authorfirst"].ToString();
            textBoxX3.Text = book_info.Rows[0]["Bookname"].ToString();
            }
            catch (Exception excp)
            {
                Exception myExcp = new Exception("Could not view transaction " + excp.Message, excp);
                throw (myExcp);
            }
            //calculateSums();
        }

        private void Form2_Activated(object sender, EventArgs e)
        {
            FillBook();
        }

        public void calculateSums()
        {
            int size = bookdetails.gridView1.RowCount;

            decimal col1;
            decimal col2;
            decimal col3;

            for(int i=1; i < size; i++)
            {
                try
                {
                    if (bookdetails.gridView1.GetRowCellValue(i-1, "Sum").ToString() != "")
                    {
                        col1 = Decimal.Parse(bookdetails.gridView1.GetRowCellValue(i - 1, "Sum").ToString(), NumberStyles.Currency);
                    }
                    else
                        col1 = 0;
                    if (bookdetails.gridView1.GetRowCellValue(i, "Sum").ToString() != "")
                    {
                        col2 = Decimal.Parse(bookdetails.gridView1.GetRowCellValue(i, "Sum").ToString(), NumberStyles.Currency);
                    }
                    else
                        col2 = 0;

                    col3 = col1 + col2;
                    bookdetails.gridView1.SetRowCellValue(i, "Sum", col3);
                   
                }
                catch (Exception excp)
                {
                    Exception myExcp = new Exception("Δεν ήταν δυνατή η προβολή της συναλλαγής " + excp.Message, excp);
                    throw (myExcp);
                }
            }
            //MessageBox.Show(bookdetails.gridView1.RowCount.ToString());
            //bookdetails.gridView1.Columns["Sum"].SummaryItem. = bookdetails.gridView1.RowCount.ToString();
        }

        private void buttonX4_Click(object sender, EventArgs e)
        {
            if (!bookdetails.gridControl1.IsPrintingAvailable)
            {
                MessageBox.Show("The 'DevExpress.XtraPrinting' Library is not found", "Error");
                return;
            }
            // Opens the Preview window.
            PrintingSystem printingSystem = new PrintingSystem();
            PrintableComponentLink link = new PrintableComponentLink(printingSystem);
            bookdetails.gridView1.OptionsPrint.UsePrintStyles = true;

            link.Component = bookdetails.gridControl1;
            link.PaperKind = System.Drawing.Printing.PaperKind.A4;

            link.Margins.Left = 3;
            link.Margins.Top = 2;
            link.Margins.Right = 3;
            link.CreateReportHeaderArea += new CreateAreaEventHandler(printableComponentLink2_CreateReportHeaderArea);

            link.CreateDocument();
            link.ShowPreview();
            //bookdetails.gridView1.OptionsPrint.EnableAppearanceEvenRow = false;
            //bookdetails.gridView1.OptionsPrint.EnableAppearanceOddRow = false;
            //bookdetails.gridControl1.ShowPrintPreview();



        }

        public void printableComponentLink2_CreateReportHeaderArea(object sender, CreateAreaEventArgs e)
        {
            string reportHeader = textBoxX1.Text.ToString() + " " + textBoxX2.Text.ToString() + "-" + textBoxX3.Text.ToString();
            e.Graph.Font = new Font("Arial", 10, FontStyle.Bold);
            RectangleF rec = new RectangleF(0, 0, e.Graph.ClientPageSize.Width, 30);
            e.Graph.DrawString(reportHeader, Color.Black, rec, BorderSide.None);
        }

        private void comboBoxEx1_SelectedIndexChanged(object sender, EventArgs e)
        {
            bookdetails.gridView1.ActiveFilterString = "[Date] Like '%" + comboBoxEx1.SelectedItem.ToString() + "'";
        }

        private void buttonX5_Click(object sender, EventArgs e)
        {
            //int test3 = bookdetails.gridView1.GetRowLevel(bookdetails.gridView1.FocusedRowHandle);
            DataRow test2 = bookdetails.gridView1.GetFocusedDataRow();
            int row = Int32.Parse(test2["espcode"].ToString());
            DialogResult reply = MessageBoxEx.Show("Θέλετε σίγουρα να διαγράψετε την συναλλαγή της " + test2["Date"] + "?", "Διαγραφή Συναλλαγής", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

            if (reply == DialogResult.Yes)
            {
                DbWrapper myWrapper = new DbWrapper(Program.server_ip, Program.database, Program.username, "newton");
                myWrapper.Connect();
                myWrapper.delete_trans(row);
                myWrapper.Disconnect();
                FillBook();

            }
        }

        private void textBoxX1_Leave(object sender, EventArgs e)
        {
            string replace;

            if (textBoxX1.Modified)
            {
                replace = textBoxX1.Text.ToString().Replace("'", "''");
                DialogResult reply = MessageBoxEx.Show("Το επίθετο του συγγραφέα έχει αλλάξει.\nΘέλετε να αποθηκεύσετε την αλλαγή;\n" + replace, "Αλλα", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                if (reply == DialogResult.Yes)
                {
                    DbWrapper myWrapper = new DbWrapper(Program.server_ip, Program.database, Program.username, "newton");
                    myWrapper.Connect();
                    myWrapper.Update_Author("Authorlast", replace, rowid.ToString());
                    myWrapper.Disconnect();

                    textBoxX1.Text = replace;
                }

            }
        }

        private void textBoxX2_Leave(object sender, EventArgs e)
        {
            string replace;

            if (textBoxX2.Modified)
            {
                replace = textBoxX2.Text.ToString().Replace("'", "''");
                DialogResult reply1 = MessageBoxEx.Show("Το όνομα του συγγραφέα έχει αλλάξει.\nΘέλετε να αποθηκεύσετε την αλλαγή; " + replace, "Αλλα", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                if (reply1 == DialogResult.Yes)
                {
                    DbWrapper myWrapper = new DbWrapper(Program.server_ip, Program.database, Program.username, "newton");
                    myWrapper.Connect();
                    myWrapper.Update_Author("Authorfirst", replace, rowid.ToString());
                    myWrapper.Disconnect();

                    textBoxX2.Text = replace;
                }
                
            }
            
        }

        private void textBoxX3_Leave(object sender, EventArgs e)
        {
            string replace;
            if (textBoxX3.Modified)
            {
                replace = textBoxX3.Text.ToString().Replace("'", "''");
                DialogResult reply2 = MessageBoxEx.Show("Ο τίτλος του βιβλίου έχει αλλάξει.\nΘέλετε να αποθηκεύσετε την αλλαγή; " + replace, "Αλλα", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                if (reply2 == DialogResult.Yes)
                {
                    DbWrapper myWrapper = new DbWrapper(Program.server_ip, Program.database, Program.username, "newton");
                    myWrapper.Connect();
                    myWrapper.Update_Author("Bookname", replace, rowid.ToString());
                    myWrapper.Disconnect();
                    textBoxX3.Text = replace;

                }
                
            }
            
        }
    }


}
