﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Collections.Specialized;
using DevExpress.XtraPrinting;
using System.Globalization;

namespace books
{
    public partial class search : DevComponents.DotNetBar.Office2007Form
    {
        public search()
        {

            search_panel = new books.search_panel();
            bydate_panel = new books.search_bydate();
            InitializeComponent();

            combo.Focus();


            panel1.Controls.Add(search_panel);
            search_panel.Dock = DockStyle.Fill;
            panel2.Controls.Add(bydate_panel);
            bydate_panel.Dock = DockStyle.Fill;

            DataTable customers_full = new DataTable();
            DbWrapper myWrapper = new DbWrapper(Program.server_ip, Program.database, Program.username, "newton");
            myWrapper.Connect();
            customers_full = myWrapper.authors_list();


            myWrapper.Disconnect();

            StringCollection strings = new StringCollection();



            for (int i = 0; i < customers_full.Rows.Count; i++)
            {

                combo.AutoCompleteCustomSource.Add((customers_full.Rows[i][0].ToString()));
            }






        }

        private void search_Load(object sender, EventArgs e)
        {

        }







        private void buttonX2_Click(object sender, EventArgs e)
        {
            
            if (dateTimeInput1.Text.ToString() == "" && dateTimeInput2.Text.ToString() == "")
            {
                string search_criteria = combo.Text;
                string search_criteria2 = combo2.Text;

                DataTable customer = new DataTable();

                DbWrapper myWrapper = new DbWrapper(Program.server_ip, Program.database, Program.username, "newton");
                myWrapper.Connect();
                customer = myWrapper.search_books(search_criteria, search_criteria2);


                myWrapper.Disconnect();

                search_panel.gridControl1.DataSource = customer;

                search.ActiveForm.Height = 600;
                search_panel.Dock = DockStyle.Fill;
                search_panel.Visible = true;
                panel1.Visible = true;
            }
            else
            {
                buttonX3.Visible = true;
                buttonX4.Visible = true;
                string search_criteria = combo.Text;
                string search_criteria2 = combo2.Text;
                DataTable bydate = new DataTable();
                DataTable bydate2 = new DataTable();
                string startDate = dateTimeInput1.Text.ToString();
                string endDate = dateTimeInput2.Text.ToString();
                DbWrapper myWrapper = new DbWrapper(Program.server_ip, Program.database, Program.username, "newton");
                myWrapper.Connect();

                bydate = myWrapper.search_bydate(search_criteria, search_criteria2, dateTimeInput1.Value.ToString("yyyy-MM-dd HH:mm:ss"), dateTimeInput2.Value.ToString("yyyy-MM-dd HH:mm:ss"));

                bydate2.Locale = System.Globalization.CultureInfo.InvariantCulture;
                myWrapper.Disconnect();

                try
                {
                    bydate2 = resultRows( bydate );
                    //bydate.AcceptChanges();
                    bydate_panel.gridControl1.DataSource = bydate2;
                }
                catch (Exception excp)
                {
                    Exception myExcp = new Exception( excp.Message, excp );
                    throw ( myExcp );
                }
                search.ActiveForm.Height = 700;
                for (int i = 0; i < bydate_panel.gridView1.Columns.Count - 1; i++)
                    bydate_panel.gridView1.Columns[i].OptionsColumn.FixedWidth = false;
                bydate_panel.gridView1.BestFitColumns();

                search_panel.Visible = false;
                bydate_panel.Visible = true;
                panel2.Visible = true;
                panel1.Visible = false;
            }
          //  this.FormBorderStyle = FormBorderStyle.Sizable;




        }
        public DataTable resultRows(DataTable table)
        {
            try
            {
                Int32 copies;
                float papers, s1sum, s2sum, s3sum, s4sum, s5sum, s6sum, s7sum, s8sum, s9sum, tsum;
                ArrayList delete = new ArrayList();
                DataTable tmptable = table.Clone();
                tmptable.Locale = System.Globalization.CultureInfo.InvariantCulture;
                for (int i = 0; i < table.Rows.Count; i++)
                {
                    if (!delete.Contains( table.Rows[i]["Bookname"].ToString() ))
                    {
                        DataRow row = tmptable.NewRow();
                        row["Bookcode"] = table.Rows[i]["Bookcode"].ToString();
                        row["Bookname"] = table.Rows[i]["Bookname"].ToString();
                        row["Authorname"] = table.Rows[i]["Authorname"].ToString();
                        if (table.Rows[i]["Papers"].ToString() != "")
                            papers = float.Parse( table.Rows[i]["Papers"].ToString() );
                        else
                            papers = 0;
                        if (table.Rows[i]["Copies"].ToString() != "")
                            copies = Int32.Parse( table.Rows[i]["Copies"].ToString() );
                        else
                            copies = 0;
                        if (table.Rows[i]["S1"].ToString() != "")
                            s1sum = float.Parse( table.Rows[i]["S1"].ToString() );
                        else
                            s1sum = 0;
                        if (table.Rows[i]["S2"].ToString() != "")
                            s2sum = float.Parse( table.Rows[i]["S2"].ToString() );
                        else
                            s2sum = 0;
                        if (table.Rows[i]["S3"].ToString() != "")
                            s3sum = float.Parse( table.Rows[i]["S3"].ToString() );
                        else
                            s3sum = 0;
                        if (table.Rows[i]["S4"].ToString() != "")
                            s4sum = float.Parse( table.Rows[i]["S4"].ToString() );
                        else
                            s4sum = 0;
                        if (table.Rows[i]["S5"].ToString() != "")
                            s5sum = float.Parse( table.Rows[i]["S5"].ToString() );
                        else
                            s5sum = 0;
                        if (table.Rows[i]["S6"].ToString() != "")
                            s6sum = float.Parse( table.Rows[i]["S6"].ToString() );
                        else
                            s6sum = 0;
                        if (table.Rows[i]["S7"].ToString() != "")
                            s7sum = float.Parse( table.Rows[i]["S7"].ToString() );
                        else
                            s7sum = 0;
                        if (table.Rows[i]["S8"].ToString() != "")
                            s8sum = float.Parse( table.Rows[i]["S8"].ToString() );
                        else
                            s8sum = 0;
                        if (table.Rows[i]["S9"].ToString() != "")
                            s9sum = float.Parse( table.Rows[i]["S9"].ToString() );
                        else
                            s9sum = 0;
                        if (table.Rows[i]["Sum"].ToString() != "")
                            tsum = float.Parse( table.Rows[i]["Sum"].ToString() );
                        else
                            tsum = 0;

                        for (int j = i + 1; j < table.Rows.Count; j++)
                        {
                            if (table.Rows[i]["Bookname"].ToString() == table.Rows[j]["Bookname"].ToString())
                            {
                                if (table.Rows[i]["Papers"].ToString() != "")
                                    papers = papers + float.Parse( table.Rows[i]["Papers"].ToString() );
                                if (table.Rows[i]["Copies"].ToString() != "")
                                    copies = copies + Int32.Parse( table.Rows[i]["Copies"].ToString() );
                                if ( String.IsNullOrEmpty(table.Rows[j]["S1"].ToString()) == false )
                                    s1sum = s1sum + float.Parse( table.Rows[j]["S1"].ToString() );
                                if (String.IsNullOrEmpty(table.Rows[j]["S2"].ToString()) == false )
                                    s2sum = s2sum + float.Parse( table.Rows[j]["S2"].ToString() );
                                if (String.IsNullOrEmpty(table.Rows[j]["S3"].ToString()) == false)
                                    s3sum = s3sum + float.Parse( table.Rows[j]["S3"].ToString() );
                                if (String.IsNullOrEmpty(table.Rows[j]["S4"].ToString()) == false)
                                    s4sum = s4sum + float.Parse( table.Rows[j]["S4"].ToString() );
                                if (String.IsNullOrEmpty(table.Rows[j]["S5"].ToString()) == false)
                                    s5sum = s5sum + float.Parse( table.Rows[j]["S5"].ToString() );
                                if (String.IsNullOrEmpty(table.Rows[j]["S6"].ToString()) == false)
                                    s6sum = s6sum + float.Parse( table.Rows[j]["S6"].ToString() );
                                if (String.IsNullOrEmpty(table.Rows[j]["S7"].ToString()) == false)
                                    s7sum = s7sum + float.Parse( table.Rows[j]["S7"].ToString() );
                                if (String.IsNullOrEmpty(table.Rows[j]["S8"].ToString()) == false)
                                    s8sum = s8sum + float.Parse( table.Rows[j]["S8"].ToString() );
                                if (String.IsNullOrEmpty(table.Rows[j]["S9"].ToString()) == false)
                                    s9sum = s9sum + float.Parse( table.Rows[j]["S9"].ToString() );
                                if (String.IsNullOrEmpty( table.Rows[j]["Sum"].ToString() ) == false)
                                    tsum = tsum + float.Parse( table.Rows[j]["Sum"].ToString() );
                            }
                        }
                        try
                        {
                            row["Copies"] = copies;
                            row["Papers"] = papers;
                            row["S1"] = s1sum;
                            row["S2"] = s2sum;
                            row["S3"] = s3sum;
                            row["S4"] = s4sum;
                            row["S5"] = s5sum;
                            row["S6"] = s6sum;
                            row["S7"] = s7sum;
                            row["S8"] = s8sum;
                            row["S9"] = s9sum;
                            row["Sum"] = tsum;
                            delete.Add( row["Bookname"].ToString() );
                            tmptable.Rows.Add( row );
                        }
                        catch (Exception excp)
                        {
                            Exception myExcp = new Exception( "Δεν ήταν δυνατή η προβολή της συναλλαγής " + excp.Message, excp );
                            throw ( myExcp );
                        }
                    }
                }
                for (int k = 0; k < table.Rows.Count; k++)
                {
                    bool yeap = delete.Contains( table.Rows[k]["Bookname"].ToString() );
                    if (!yeap)
                    {

                        DataRow row = tmptable.NewRow();
                        row["Bookname"] = table.Rows[k]["Bookname"].ToString();
                        row["Authorname"] = table.Rows[k]["Authorname"].ToString();
                        if (table.Rows[k]["S3"].ToString() == "")
                        {
                            row["S3"] = 0;
                        }
                        else
                        {
                            row["S3"] = float.Parse( table.Rows[k]["S3"].ToString() );
                        }

                        tmptable.Rows.Add( row );

                    }
                }

                tmptable.AcceptChanges();

                return tmptable;
            }
            catch (Exception excp)
            {
                Exception myExcp = new Exception(excp.Message, excp );
                throw ( myExcp );
            }
        }
    
       

        public ArrayList calculateRows()
        {
            int size = bydate_panel.gridView1.RowCount;
            int columns = bydate_panel.gridView1.Columns.Count;
            MessageBox.Show(columns.ToString());
            ArrayList delete = new ArrayList();

            decimal col1;
            decimal col2;
            decimal col3;

            for (int i = 1; i < size; i++)
            {
                try
                {
                    if (bydate_panel.gridView1.GetRowCellValue(i - 1, bydate_panel.gridView1.Columns[1]).ToString() == bydate_panel.gridView1.GetRowCellValue(i, bydate_panel.gridView1.Columns[1]).ToString())
                    {
                        for (int j = 4; j < columns; j++)
                        {

                            //col1 = Decimal.Parse(bydate_panel.gridView1.GetRowCellValue(i - 1, bydate_panel.gridView1.Columns[j]).ToString(), NumberStyles.Currency);
                            //col2 = Decimal.Parse(bydate_panel.gridView1.GetRowCellValue(i, bydate_panel.gridView1.Columns[j]).ToString(), NumberStyles.Currency);
                            //MessageBox.Show((col1 + col2).ToString());
                            
                           }
                        delete.Add(i);
                    }

                }
                catch (Exception excp)
                {
                    Exception myExcp = new Exception("Δεν ήταν δυνατή η προβολή της συναλλαγής " + excp.Message, excp);
                    throw (myExcp);
                }
            }
            for (int i = 0; i < delete.Count; i++)
            {
                bydate_panel.gridView1.DeleteRow((int)delete[i]);

            }
            //MessageBox.Show(bookdetails.gridView1.RowCount.ToString());
            //bookdetails.gridView1.Columns["Sum"].SummaryItem. = bookdetails.gridView1.RowCount.ToString();
            return delete;
        }

        private void dataGridViewX1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {




        }

        private void search_KeyDown(object sender, KeyEventArgs e)
        {






        }

        private void buttonX1_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void buttonX4_Click(object sender, EventArgs e)
        {
            if (!bydate_panel.gridControl1.IsPrintingAvailable)
            {
                MessageBox.Show("The 'DevExpress.XtraPrinting' Library is not found", "Error");
                return;
            }
            // Opens the Preview window.
            PrintingSystem printingSystem = new PrintingSystem();
            PrintableComponentLink link = new PrintableComponentLink(printingSystem);
            
            bydate_panel.gridView1.OptionsPrint.UsePrintStyles = true;

            link.Component = bydate_panel.gridControl1;

            link.CreateReportHeaderArea += new CreateAreaEventHandler(printableComponentLink1_CreateReportHeaderArea);

            link.CreateDocument();

            link.PrintingSystem.Document.AutoFitToPagesWidth = 1;
           
            link.ShowPreview();
        }

        private void buttonX3_Click(object sender, EventArgs e)
        {
            string timeMark = DateTime.Now.ToString("yyyyMMdd_HHmmss");
            string desktop_path = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory).ToString();
            string fastExportFilePath = desktop_path + "\\books_" + combo.Text.ToString() + "_" + combo2.Text.ToString() + "_" + timeMark + ".xls";


            DevExpress.XtraPrinting.PrintingSystem ps = new DevExpress.XtraPrinting.PrintingSystem();

            // Create a link that will print a control.
            DevExpress.XtraPrinting.PrintableComponentLink link = new PrintableComponentLink(ps);

            // Specify the control to be printed.
            link.Component = bydate_panel.gridControl1;
          //  link.CreateReportHeaderArea += new CreateAreaEventHandler(printableComponentLink1_CreateReportHeaderArea);
            // Generate the report.
            link.CreateDocument();

            link.PrintingSystem.ExportToXls(@fastExportFilePath);

            // Use the code below if you want the created file to be automatically
            // opened in the appropriate application.
            System.Diagnostics.Process process = new System.Diagnostics.Process();
            process.StartInfo.FileName = @fastExportFilePath;
            process.Start();
        }

        /*  private void dataGridViewX1_CellContentDoubleClick(object sender, DataGridViewCellEventArgs e)
          {
              dataGridViewX1.CurrentRow.Selected = true;
              string row = dataGridViewX1.CurrentRow.Cells[0].Value.ToString();
              int rowid = Convert.ToInt32(row);

              Form3 newapp = new Form3(rowid, "update");
              newapp.Show();
              newapp.Focus();
              newapp.BringToFront();


            

          }
         *

          private void dataGridViewX1_CellClick(object sender, DataGridViewCellEventArgs e)
          {
        
          }

          private void dataGridViewX1_CellEnter(object sender, DataGridViewCellEventArgs e)
          {
              dataGridViewX1.CurrentRow.Selected = true;
          }

       

          private void dataGridViewX1_CellLeave(object sender, DataGridViewCellEventArgs e)
          {

           

          }
         * 
         * 
         */
        public void printableComponentLink1_CreateReportHeaderArea(object sender, CreateAreaEventArgs e)
        {
            string reportHeader = combo.Text.ToString() + " " + combo2.Text.ToString() ;
            e.Graph.Font = new Font("Arial", 8, FontStyle.Bold);
            RectangleF rec = new RectangleF(0, 0, e.Graph.ClientPageSize.Width, 50);
            e.Graph.DrawString(reportHeader, Color.Black, rec, BorderSide.None);
        }
    }
}